//---------------------------------------------------------------------------


#pragma hdrstop

#include "UBlif.h"


Object *Blif::getObjectFromFile(MStr file)
{
  PLAsCount = 1;
  Object *o=new Object(3,"102","000012022");
  F.open(file.c_str());
  if(!F.is_open())
    throw (MStr("nebylo mozne otevrit soubor ")+file).c_str();

  F >> noskipws;
  MStr s;
  while(true)
  {
    char c;
    F >> c;
    if(F.eof()) break;
    if(c=='\n')
    {
      if(s==".e") break;
      if(s.substr(0,8) == ".outputs")
      {
        unsigned it=8;
        while(true)
        {
          MStr is="";
          it++;
          while(it < s.length() && s[it] != ' ')
            is+=s[it++];
          Port *p=o->addPort(2,is);
          o->addPRef(p,is);
          if(it==s.length()) break;
        }
        s="";
        continue;
      }
      if(s.substr(0,6) == ".model")
      {
        MStr temp=s.substr(3,255);
        o->AdditionalParameter2 = new char[temp.length()];
        strncpy((char *)o->AdditionalParameter2,temp.c_str(),temp.length());
      }
      if(s.substr(0,7) == ".inputs")
      {
        unsigned it=7;
        while(true)
        {
          MStr is="";
          it++;
          while(it < s.length() && s[it] != ' ')
            is+=s[it++];
          Port *p=o->addPort(1,is);
          o->addPRef(p,is);
          if(it == s.length()) break;
        }
        s="";
        continue;
      }
      if(s.substr(0,6) == ".names")
      {
        Object *ob=o->addObject(MStr("PLA_")+MStr(PLAsCount++));
        ob->eval_param = "PLA_fd";
        unsigned it=6;
        int lp=s.rfind(" ");
        while(true)
        {
            MStr is="";
            it++;
            while(it < s.length() && s[it] != ' ')
              is+=s[it++];
            Port *p=ob->addPort(1,is);
            ob->addPRef(p,is);
            o->addPRef(p,is);
            if(it == lp) break;
        }
        it++;
        MStr is="";
        while(it < s.length())
          is+=s[it++];
        Port *p=ob->addPort(2,is);
        ob->addPRef(p,is);
        o->addPRef(p,is);
        list<pair<string,string> > *l=new list<pair<string,string> >;
        s="";
        while(true)
        {
          F >> c;
          if(F.eof()) break;
          if(c=='.')
          {
            F.unget();
            break;
          }
          if(c=='\n')
          {
            int p=s.find(' ');
            string s1=s.substr(0,p);
            string s2=s.substr(p+1,255);
            if(s1.length() != ob->InputPorts.size())
              throw (MStr("bad PLA")+MStr(PLAsCount-1)).c_str();
            l->push_back(pair<string,string>(s1,s2));
            s="";
          }
          else
          {
            s+=c;
          }
        }
        ob->AdditionalParameter1 = l;
        s="";
        continue;
      }
      s="";
    }
    else
    {
      s+=c;
    }
  }
  o->eval_param = MStr("BLIF");
  return o;
}

//---------------------------------------------------------------------------

#pragma package(smart_init)
