#include "logic4.h"

// ------------ usin 4 value logic ----------------

logic4Set &getIn4SetW(DDWire *dw, int &check,int val,int sval,logic4Set &sset,int rank);

logic4Set& test4W(DDWire *fw,int &check,int value,logic4Set *crossval) {
logic4Set pom1,pom2;
logic4Set vv1,vv2;
logic4Set sset1,sset2;
logic4Set *pom=new logic4Set;
if (crossval!=NULL) *pom=*crossval;
DDWire *dw;
fw->un_checked=check;
if (dbg_print) cout << "4 init:" << fw->name << " v:" << value <<" ch:" <<check << endl;
	if (fw->togate!=NULL) {
		if (dbg_print) cout << "gate" << endl;
		DDGate *dg=fw->togate;
		int xory=0;
		int sval=0,inval=0,outval; // xor defaults
		int gnot=(dg->gTyp&tNOT);
		if(gnot) outval=1-value; else outval=value;
		switch((dg->gTyp&~tNOT)) {
			case tAND: inval=1; sval=value+2; break;;
			case tOR: inval=0; sval=value+2; break;;
			case tXOR: xory=1; break;;
		} // switch
		rank=0;
		while (rank>=0) {
		if (xory) { 
			if (dbg_print) cout << "xory" << endl;
			if (dg->inwires[0]!=fw) dw=dg->inwires[0];
			else dw=dg->inwires[1];
			pom1=getIn4SetW(dw,check,inval,0,sset1,rank);
			if (crossval!=NULL) pom1=pom1*(*crossval);
			if (!pom1.isEmpty()) { 
				vv1=test4W(dg->outwire,check,outval,&pom1);
			}
			pom2=getIn4SetW(dw,check,1-inval,0,sset2,rank);
			if (crossval!=NULL) pom2=pom2*(*crossval);
			if (!pom2.isEmpty()) { 
				vv2=test4W(dg->outwire,check,1-outval,&pom2);
			}
			*pom=vv1+vv2;
		} else { // not xory
			if (dbg_print) cout << "not xor" << endl;
			int empty=0;
			int rank=2;
			if (crossval!=NULL) pom2=*crossval;
			for(int i=0;i<dg->inputs;i++) {
				dw=dg->inwires[i];
				if (dw!=fw) {
						// if (empty=(pom2.isEmpty()&&sset1.isEmpty()))
						if (empty=(pom2.isEmpty()))
							break;
				}
			} // for
			if (!empty) *pom=test4W(fw->togate->outwire,check,outval,&pom2);
			else *pom=pom2;
		} // else xory
	}// rank
	} // gate
	if (fw->towires!=NULL) {
	if (dbg_print) cout << "to wires" << endl;
	 for (int i=0;i<fw->outputs;i++) {
		/*
		if (dbg_print) { cout << "towires: pom2=";
				pom2.print(); 
				cout << "crossval="; crossval->print(); }
		*/
		pom1=test4W(fw->towires[i],check,value,crossval);
		pom2=(pom2+pom1);
	 }
	 *pom=pom2;
	} // end towires 
	else { // POUT
		// ? don't need yet
	}
if (dbg_print) pom->print();
fw->un_checked=check-1;
if (dbg_print) cout << "4 return:" << fw->name << endl;
return *pom;
}


// get set of input values to reach "val" value on gate "dg"
logic4Set &getIn4SetG(DDGate *dg, int &check,int val, int sval,logic4Set &sset,int &rank) {
int allval=vUndef, otval=vUndef, allsval=vUndef, otsval=vUndef;
int sval2=vUndef,xory=vUndef;
if (dbg_print) cout << "init:" << dg->name  << " v:" << val <<" s:" << sval << " ch:" <<check << endl;
logic4Set *pom=new logic4Set,pom1,pom2;
logic4Set sset1,sset2;
if (dbg_print) cout << "G if 1" << endl;
if (sval) sval2=sval-2;
	switch (dg->gTyp) {
		case tAND: if (val) { 
			 	allval=1; 
				if (sval) allsval=sval2; 
			}
			else {
				otval=0; 
				if (sval) otsval=sval2;  
			}
			break ;;
		case tNAND: if (!val) { 
			 	allval=1; 
				if (sval) allsval=!sval2; 
			}
			else {
				otval=0; 
				if (sval) otsval=!sval2;  
			}
			break ;; 
		case tNOT: 
			allval=!val; if (sval) allsval=!sval2; break ;;
		case tOR: if (!val) { 
			 	allval=0; 
				if (sval) allsval=sval2; 
			}
			else {
				otval=1; 
				if (sval) otsval=sval2;  
			}
			break ;;
		case tNOR: if (val) { 
			 	allval=0; 
				if (sval) allsval=!sval2; 
			}
			else {
				otval=1; 
				if (sval) otsval=!sval2;  
			}
			break ;;
		case tXOR: xory=1; break;;
		case tXNOR: xory=2; break;;
	}
	while (rank>0) {
	if (xory!=vUndef) {// it's a xor, special rules apply!
				if (dbg_print) cout << "xory" <<endl;
				int nsval2;
				if (sval) { nsval2=3-sval2; sval2+=2; }
				else { nsval2=0; sval2=0; } // sensitive and negation
				if (xory=2) val=1-val;
				// here I need both 0,1 for any result value
				pom1=getIn4SetW(dg->inwires[0],check,0,sval2,sset1,rank);
				pom2=getIn4SetW(dg->inwires[1],check,1,nsval2,sset2,rank);
				logic4Set pom3,pom4;
				logic4Set sset3,sset4;
				pom3=getIn4SetW(dg->inwires[0],check,1,nsval2,sset3,rank);
				pom4=getIn4SetW(dg->inwires[1],check,0,sval2,sset4,rank);

				if (sval2==3) sset=((pom1*sset1)+(pom2*sset2)); // sensitive 1
				else if (sval2==2) sset=((pom3*sset3)+(pom4*sset4)); // sens. 0
				// sset=sset.selection(10); // pruning try
				if (val) *pom=((pom1*pom2)+(pom3*pom4)); // for 1
				else *pom=((pom1*pom4)+(pom2*pom3)); // for 0
		} else // non xor gates
		{
			if (sval) { allsval+=2; otsval+=2; }
			else { allsval=0; otsval=0; }
			if (allval!=vUndef) { // all values needs to be se to "allval"
				if (dbg_print) cout << "allval" <<endl;
				int not_all=0;
				for (int i=0;i<dg->inputs;i++) { // need to set all values to allval, except for sensitive values if any
				  pom1=getIn4SetW(dg->inwires[i],check,allval,allsval,sset1,rank);
				  if (!sset1.isEmpty()) { // sensitive
					   if (i==0) sset2=sset1;
					   else sset2=sset2*pom1+(sset1*pom2)+sset2*sset1;
					   // !!! 3 sets, vals*sens, sens*previous, sens*sens 
					   if (pom1.isEmpty()) not_all=1;
				  } 
				  else  // not sens.
				  {
				     sset2=sset2*pom1; // empty until 1. sensitive
				     if ((i!=0)&&(pom1.isEmpty())) {
					     not_all=1;
					     break; // failed to found anything
				     }
				  }
				  // sset2=sset2.selection(10);// pruning try
				  if (i==0) pom2=pom1; // 1. to full
				  else pom2=pom2*pom1; // next to full
				// pom2=pom2.selection(10); // pruning try
				} // for
				if (!not_all) *pom=pom2;
			} else
			if (otval!=vUndef) { // some other value is needed
				if (dbg_print) cout << "otval" <<endl;
				logic4Set pom3,pom4,sset3;
				int not_ot=0; // means there could be no chance to set 1-otval
				for (int i=0;i<dg->inputs;i++) { // set desired inputs
				  pom1=getIn4SetW(dg->inwires[i],check,otval,otsval,sset1,rank);
				  if (!not_ot) { // we need this! in case of sens input only
				  pom3=getIn4SetW(dg->inwires[i],check,1-otval,0,sset3,rank);
				  if (!sset1.isEmpty()) { // 1-val could be set, add to sets
					  sset2=sset1*pom4+sset1*sset2;
					  // sset2=sset1+sset2+sset2*sset1;

				   } else {
				    if (pom3.isEmpty()) not_ot=1;
				    sset2=sset2*pom3;
				   }
				    // sset2=sset2.selection(10); // pruning try
				    pom4=pom4*pom3; 
				    if(i==0)  pom4=pom3;
				  } // not_ot
				  pom2=pom2+pom1;
				  // pom2=pom2.selection(10);// pruning try
				} // for
				*pom=pom2;
			} // if otval
		} // else xor 
	} // while
if (dbg_print) {
	cout << "sset:" << endl; sset2.print();
	cout << "retur:" << endl; pom->print();
	cout << "G return" << endl; }

sset=sset2;
return *pom;
}


// get set of input values to reach "val" value on wire "dw"
logic4Set &getIn4SetW(DDWire *dw, int &check,int val,int sval,logic4Set &sset,int rank) {
logic4Set *pom4Set=new logic4Set;
logic4Set *PINs;
if (dbg_print) cout << "init " << dw->name << " v=" << val << " s=" <<sval  << " wch:" <<dw->un_checked << " ch:" <<check << endl;
PINs=dw->PINs;
if (dbg_print) cout << "if 1" << endl;
if (PINs[val].isEmpty()&&(dw->un_checked!=check)&&(PINs[val].getRank()<rank))  { // not sensitive
// if (PINs[val].isEmpty()&&(dw->state!=pSens))  {
if (dbg_print) cout << "if 2" << endl;
 if (dw->fromgate!=NULL) 
	PINs[val]=getIn4SetG(dw->fromgate,check,val,sval,PINs[sval],rank);
 else if (dw->fromwire!=NULL) 
	PINs[val]=getIn4SetW(dw->fromwire,check,val,sval,PINs[sval],rank);
      else if (dw->cpin>=0) PINs[val].makePIN(dw->cpin,val); // primary input 
      // I need no of this pin - cpin
 *pom4Set=PINs[val].getFrom(rank);
} else { // not empty, return already found value
if (dbg_print) cout << "else 1" << endl;
	if (dw->un_checked==check) { 
	// if (dw->state==pSens) { 
		if (dbg_print)	cout << "elif 1" << endl;
		sset=dw->PINs[sval]; 
	}
	else { 
		if (dbg_print) cout << "elel 1" << endl;
		// *pom4Set=(PINs[val]); 
		*pom4Set=PINs[val].getFrom(rank); 
		if(dbg_print) 	cout << "elel s:" << sval << endl;
		if (sval) sset=dw->PINs[sval]; 
	} 
	// ! operator= should be changed not to copy pointers only >?
}
if (dbg_print) { 
 pom4Set->print(); 
 cout << "return" << endl;
}
 return *pom4Set;
}


// function for partial getting wires sets*
logic4Set &getWSet(DDWire **wires,int check, int value, sval, logic4Set &sset,int rank, int n) {
logic4Set pom,others; 
logic4Set pom; 
pom=getIn4SetW(wires[n],check,val,sval,sset,2);
while 
 if (n>0) others=getWSet(wires,n-1);


if (dbg_print) cout << "setting:" << i << endl;
pom1=getIn4SetW(dw,check,inval,sval,sset1,rank);
*pom3=(pom2*(pom1+sset1));
if (pom2.isEmpty()) pom2=(pom1+sset1);
else pom2=(pom2*(pom1+sset1));
}
