#include "bench.h"
#include "UMStr.h"
#include "Upla.h"
#include "UBlif.h"
#include "structure.h"

#ifndef hUtility
#define hUtility

//---------------------------------------------------------------------------
void save(Object *o,const char *filename);
Object *open(const char* inputfile);
void printCircuit(Object *o);
void reduceFL(DDObj *obvod);
void printFL(DDObj *obvod,int full);
void close(Object *o);

//----------pruchod strukturou-----------
// DDWire *getWire(Wire *ww,Port *pp);
DDWire *getWire(Wire *ww,Port *pp,int lev,int &olev);  // create new wire from structure
// DDGate *getGate(Object *ob);
DDGate *getGate(Object *ob,int lev,int &olev);
DDWire *getWires(Port *pp);

DDObj *transform(char *fname);

void sens(Wire *w);
void sensI(Wire *w);
void faultList(Object *o);
void faultListI(Object *o);
void testCirc(); 
int **makeTestVectors(DDObj *obvod);
int **makeTestVectorsS(DDObj *obvod);

int **readVectors(char *fname);
void printVector(int *V);
void printVector(int *V,int size);

#endif

