//---------------------------------------------------------------------------


#pragma hdrstop

#include "Upla.h"


Object *PLA::getObjectFromFile(MStr file)
{
  Object *o=new Object(3,"102","000012022");
  data.clear();
  F.open(file.c_str());
  if(!F.is_open())
    throw (MStr("nebylo mozne otevrit soubor ")+file).c_str();
  n_inputs=n_outputs=0;
  F >> noskipws;
  MStr s;
  while(true)
  {
    char c;
    F >> c;
    if(F.eof()) break;
    if(c=='\n')
    {
      if(s==".e") break;
      if(s.substr(0,3) == ".ob")
      {
        unsigned it=3;
        for(int i=0;i<n_outputs;i++)
        {
          MStr is="";
          it++;
          while(it < s.length() && s[it] != ' ')
            is+=s[it++];
          Port *p=o->addPort(2,is);
          o->addPRef(p,is);
        }
        s="";
        continue;
      }
      if(s.substr(0,2) == ".N")
      {
        MStr temp=s.substr(3,255);
        o->AdditionalParameter2 = new char[temp.length()];
        strncpy((char *)o->AdditionalParameter2,temp.c_str(),temp.length());
      }
      if(s.substr(0,2) == ".type")
      {
        type = s.substr(6,255).c_str();
      }
      if(s.substr(0,2) == ".I")
      {
        int f=s.find("\"");
        MStr temp=s.substr(f+1,255);
        int l=temp.find("\"");
        temp.resize(l);
        o->addPRef(o->addPort(1,temp),temp);
      }
      if(s.substr(0,2) == ".O")
      {
        int f=s.find("\"");
        MStr temp=s.substr(f+1,255);
        int l=temp.find("\"");
        temp.resize(l);
        o->addPRef(o->addPort(2,temp),temp);
      }
      if(s.substr(0,4) == ".ilb")

      {
        unsigned it=4;
        for(int i=0;i<n_inputs;i++)
        {
          MStr is="";
          it++;
          while(it < s.length() && s[it] != ' ')
            is+=s[it++];
          Port *p=o->addPort(1,is);
          o->addPRef(p,is);
        }
        s="";
        continue;
      }
      if(s.substr(0,2) == ".i")
      {
        n_inputs = atoi(s.substr(3,255).c_str());
        s="";
        continue;
      }
      if(s.substr(0,2) == ".o")
      {
        n_outputs = atoi(s.substr(3,255).c_str());
        s="";
        continue;
      }
      if(s.substr(0,2) == ".p")
      {
        s="";
        continue;
      }
      data.push_back(s);
      s="";
    }
    else
    {

      s+=c;
    }
  }
  if(n_inputs && n_outputs)
  {
    for(int i=o->InputPorts.size();i<n_inputs;i++)
    {
      MStr temp = MStr("IPort_")+MStr(i);
      o->addPRef(o->addPort(1,temp),temp);
    }
    for(int i=o->OutputPorts.size();i<n_outputs;i++)
    {
      MStr temp = MStr("OPort_")+MStr(i);
      o->addPRef(o->addPort(2,temp),temp);
    }
  }
  else
  {
    throw ".i and/or .o not specified";
  }

  if(type=="") type="fd";
  o->eval_param = MStr("PLA_")+type;
  list<pair<string,string> > *l;
  l=new list<pair<string,string> >;
  for(vector<MStr>::iterator i=data.begin();i!=data.end();i++)
  {
    int p=i->find(' ');
    string s1=i->substr(0,p);
    string s2=i->substr(p+1,255);
    if(s1.length() != o->InputPorts.size()) continue;
    l->push_back(pair<string,string>(s1,s2));
  }
  o->AdditionalParameter1 = l;
  return o;
}

//---------------------------------------------------------------------------

#pragma package(smart_init)

