#ifndef hDebug
#define hDebug

// debugging macros
#ifdef _DBG_

#ifndef DBG_DO
	#define DBG_DO(statement) if (dbg_print) { statement; } else 0
#endif
#ifndef DBG_Cout
	#define DBG_Cout(xcoutx) if (dbg_print) cout << xcoutx; else 0
#endif
#ifndef DBG2_Cout
	#define DBG2_Cout(xcoutx,n) if (dbg_print>n) cout << xcoutx; else 0
#endif
#ifndef DBG_Print
	#define DBG_Print(xprintx) if (dbg_print) printf(xprintx); else 0
#endif
#ifndef DBG2_Print
	#define DBG2_Print(xprintx,n) if (dbg_print>n) printf(xprintx); else 0
#endif
#else // no debug
	#define DBG_DO(statement) 0
	#define DBG_Cout(xcoutx) 0
	#define DBG2_Cout(xcoutx,n) 0
	#define DBG_Print(xprintx) 0
	#define DBG2_Print(xprintx,n) 0
#endif

#endif // hDebug
