//---------------------------------------------------------------------------

#ifndef lexanH
#define lexanH
//---------------------------------------------------------------------------
// #include <vcl.h>
#include <iostream>
#include <fstream>
//#include <stdlib.h>
#include <list>
#include <stdexcept>

#include "UMStr.h"

using namespace std;
//---------------------------------------------------------------------------
#define LEX_NULL     0
#define LEX_ERROR    1
#define LEX_INPUT    1000  //kw
#define LEX_OUTPUT   1001  //kw
#define LEX_DFF      4  //kw
#define LEX_AND      5  //kw
#define LEX_OR       6  //kw
#define LEX_NAND     7  //kw
#define LEX_NOR      8  //kw
#define LEX_XOR      9  //kw
#define LEX_XNOR     10 //kw
#define LEX_NOT      11 //kw
#define LEX_BUFF     12 //kw

//#define LEX_WRITE    13
//#define LEX_LBR      14
//#define LEX_RBR      15
#define LEX_INTEGER  16
#define LEX_REAL     17
//#define LEX_PLUS     18
//#define LEX_MULT     19
//#define LEX_COLON    20
#define LEX_ASSIGN   21
//#define LEX_DIV      22
#define LEX_LPA      23
#define LEX_RPA      24
//#define LEX_ELSE     25
//#define LEX_THEN     26
//#define LEX_DOT      27

#define LEX_IDENT    28

//#define LEX_SEMICOLON 29
#define LEX_COMMA    30
//#define LEX_TYPEINT  31
//#define LEX_TYPEREAL 32
//#define LEX_DO       33

#define MODE_STANDARD 0  // bench,...
//---------------------------------------------------------------------------

class Lexan
{
   ifstream F;
   int mode;
   list<pair<int,MStr> > keywords;
   void kw_init();
 public:
   int Lex_AInt;
   double Lex_AReal;
   MStr Lex_AStr;
   int rowcount;
   Lexan(const char *,int=MODE_STANDARD);
   Lexan(){};
   void init(const char *,int=MODE_STANDARD);
   int NextToken();
   ~Lexan(){F.close();}
};

//---------------------------------------------------------------------------


#endif
